-- -------------------------------------------------------------
-- 
-- File Name: hdl_prj\hdlsrc\lms\LMS.vhd
-- Created: 2015-06-19 16:39:42
-- 
-- Generated by MATLAB 8.5 and HDL Coder 3.6
-- 
-- 
-- -------------------------------------------------------------
-- Rate and Clocking Details
-- -------------------------------------------------------------
-- Model base rate: 2.26757e-05
-- Target subsystem base rate: 2.26757e-05
-- 
-- 
-- Clock Enable  Sample Time
-- -------------------------------------------------------------
-- ce_out        2.26757e-05
-- -------------------------------------------------------------
-- 
-- 
-- Output Signal                 Clock Enable  Sample Time
-- -------------------------------------------------------------
-- e_k                           ce_out        2.26757e-05
-- -------------------------------------------------------------
-- 
-- -------------------------------------------------------------


-- -------------------------------------------------------------
-- 
-- Module: LMS
-- Source Path: lms/LMS
-- Hierarchy Level: 0
-- 
-- -------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;
USE work.LMS_pkg.ALL;

ENTITY LMS IS
  PORT( clk                               :   IN    std_logic;
        reset                             :   IN    std_logic;
        clk_enable                        :   IN    std_logic;
        x_k                               :   IN    std_logic_vector(15 DOWNTO 0);  -- sfix16_En14
        d_k                               :   IN    std_logic_vector(15 DOWNTO 0);  -- sfix16_En14
        ce_out                            :   OUT   std_logic;
        e_k                               :   OUT   std_logic_vector(15 DOWNTO 0)  -- sfix16_En14
        );
END LMS;


ARCHITECTURE rtl OF LMS IS

  -- Constants
  CONSTANT C_LMS_FILTER_STEP_SIZE         : signed(15 DOWNTO 0) := "0100000000000000";  -- sfix16_En17

  -- Signals
  SIGNAL enb                              : std_logic;
  SIGNAL x_k_signed                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL d_k_signed                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL LMS_Filter_out1                  : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL LMS_Filter_out2                  : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL weight                           : vector_of_signed16(0 TO 15);  -- sfix16_En14 [16]
  SIGNAL filter_sum                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL data_pipeline                    : vector_of_signed16(0 TO 15);  -- sfix16_En14 [16]
  SIGNAL data_pipeline_tmp                : vector_of_signed16(0 TO 14);  -- sfix16_En14 [15]
  SIGNAL filter_products                  : vector_of_signed16(0 TO 15);  -- sfix16_En14 [16]
  SIGNAL mul_temp                         : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_1                       : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_2                       : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_3                       : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_4                       : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_5                       : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_6                       : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_7                       : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_8                       : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_9                       : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_10                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_11                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_12                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_13                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_14                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_15                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL sum_1                            : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast                         : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_1                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp                         : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_2                            : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_2                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_3                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_1                       : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_3                            : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_4                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_5                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_2                       : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_4                            : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_6                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_7                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_3                       : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_5                            : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_8                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_9                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_4                       : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_6                            : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_10                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_11                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_5                       : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_7                            : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_12                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_13                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_6                       : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_8                            : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_14                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_15                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_7                       : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_9                            : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_16                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_17                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_8                       : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_10                           : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_18                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_19                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_9                       : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_11                           : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_20                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_21                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_10                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_12                           : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_22                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_23                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_11                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_13                           : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_24                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_25                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_12                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sum_14                           : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_26                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_27                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_13                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_28                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_29                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_14                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL sub_cast                         : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL sub_cast_1                       : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL sub_temp                         : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL mu_err                           : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL mul_temp_16                      : signed(31 DOWNTO 0);  -- sfix32_En31
  SIGNAL mu_err_data_prod                 : vector_of_signed16(0 TO 15);  -- sfix16_En14 [16]
  SIGNAL mul_temp_17                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_18                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_19                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_20                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_21                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_22                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_23                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_24                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_25                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_26                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_27                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_28                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_29                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_30                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_31                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL mul_temp_32                      : signed(31 DOWNTO 0);  -- sfix32_En28
  SIGNAL weight_adder_output              : vector_of_signed16(0 TO 15);  -- sfix16_En14 [16]
  SIGNAL add_cast_30                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_31                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_15                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_32                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_33                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_16                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_34                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_35                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_17                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_36                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_37                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_18                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_38                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_39                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_19                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_40                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_41                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_20                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_42                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_43                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_21                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_44                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_45                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_22                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_46                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_47                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_23                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_48                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_49                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_24                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_50                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_51                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_25                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_52                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_53                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_26                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_54                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_55                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_27                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_56                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_57                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_28                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_58                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_59                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_29                      : signed(16 DOWNTO 0);  -- sfix17_En14
  SIGNAL add_cast_60                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_cast_61                      : signed(15 DOWNTO 0);  -- sfix16_En14
  SIGNAL add_temp_30                      : signed(16 DOWNTO 0);  -- sfix17_En14

BEGIN
  x_k_signed <= signed(x_k);

  d_k_signed <= signed(d_k);

  enb <= clk_enable;


-- ***********************
-- ********* LMS *********
-- ***********************

-- * LMS: FIR section

  LMS_Filter_del_temp_process1 : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      data_pipeline_tmp <= (OTHERS => (OTHERS => '0'));
    ELSIF clk'event AND clk = '1' THEN
      IF enb = '1' THEN
        data_pipeline_tmp(0 TO 13) <= data_pipeline_tmp(1 TO 14);
        data_pipeline_tmp(14) <= x_k_signed;
      END IF;
    END IF;
  END PROCESS LMS_Filter_del_temp_process1;

  data_pipeline(0 TO 14) <= data_pipeline_tmp(0 TO 14);
  data_pipeline(15) <= x_k_signed;

  mul_temp <= data_pipeline(0) * weight(0);
  filter_products(0) <= resize(shift_right(mul_temp(29 DOWNTO 0) + ( "0" & (mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14) & NOT mul_temp(14))), 14), 16);

  mul_temp_1 <= data_pipeline(1) * weight(1);
  filter_products(1) <= resize(shift_right(mul_temp_1(29 DOWNTO 0) + ( "0" & (mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14) & NOT mul_temp_1(14))), 14), 16);

  mul_temp_2 <= data_pipeline(2) * weight(2);
  filter_products(2) <= resize(shift_right(mul_temp_2(29 DOWNTO 0) + ( "0" & (mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14) & NOT mul_temp_2(14))), 14), 16);

  mul_temp_3 <= data_pipeline(3) * weight(3);
  filter_products(3) <= resize(shift_right(mul_temp_3(29 DOWNTO 0) + ( "0" & (mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14) & NOT mul_temp_3(14))), 14), 16);

  mul_temp_4 <= data_pipeline(4) * weight(4);
  filter_products(4) <= resize(shift_right(mul_temp_4(29 DOWNTO 0) + ( "0" & (mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14) & NOT mul_temp_4(14))), 14), 16);

  mul_temp_5 <= data_pipeline(5) * weight(5);
  filter_products(5) <= resize(shift_right(mul_temp_5(29 DOWNTO 0) + ( "0" & (mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14) & NOT mul_temp_5(14))), 14), 16);

  mul_temp_6 <= data_pipeline(6) * weight(6);
  filter_products(6) <= resize(shift_right(mul_temp_6(29 DOWNTO 0) + ( "0" & (mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14) & NOT mul_temp_6(14))), 14), 16);

  mul_temp_7 <= data_pipeline(7) * weight(7);
  filter_products(7) <= resize(shift_right(mul_temp_7(29 DOWNTO 0) + ( "0" & (mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14) & NOT mul_temp_7(14))), 14), 16);

  mul_temp_8 <= data_pipeline(8) * weight(8);
  filter_products(8) <= resize(shift_right(mul_temp_8(29 DOWNTO 0) + ( "0" & (mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14) & NOT mul_temp_8(14))), 14), 16);

  mul_temp_9 <= data_pipeline(9) * weight(9);
  filter_products(9) <= resize(shift_right(mul_temp_9(29 DOWNTO 0) + ( "0" & (mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14) & NOT mul_temp_9(14))), 14), 16);

  mul_temp_10 <= data_pipeline(10) * weight(10);
  filter_products(10) <= resize(shift_right(mul_temp_10(29 DOWNTO 0) + ( "0" & (mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14) & NOT mul_temp_10(14))), 14), 16);

  mul_temp_11 <= data_pipeline(11) * weight(11);
  filter_products(11) <= resize(shift_right(mul_temp_11(29 DOWNTO 0) + ( "0" & (mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14) & NOT mul_temp_11(14))), 14), 16);

  mul_temp_12 <= data_pipeline(12) * weight(12);
  filter_products(12) <= resize(shift_right(mul_temp_12(29 DOWNTO 0) + ( "0" & (mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14) & NOT mul_temp_12(14))), 14), 16);

  mul_temp_13 <= data_pipeline(13) * weight(13);
  filter_products(13) <= resize(shift_right(mul_temp_13(29 DOWNTO 0) + ( "0" & (mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14) & NOT mul_temp_13(14))), 14), 16);

  mul_temp_14 <= data_pipeline(14) * weight(14);
  filter_products(14) <= resize(shift_right(mul_temp_14(29 DOWNTO 0) + ( "0" & (mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14) & NOT mul_temp_14(14))), 14), 16);

  mul_temp_15 <= data_pipeline(15) * weight(15);
  filter_products(15) <= resize(shift_right(mul_temp_15(29 DOWNTO 0) + ( "0" & (mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14) & NOT mul_temp_15(14))), 14), 16);

-- linear sum of filter products

  add_cast <= filter_products(0);
  add_cast_1 <= filter_products(1);
  add_temp <= resize(add_cast, 17) + resize(add_cast_1, 17);
  sum_1 <= add_temp(15 DOWNTO 0);

  add_cast_2 <= sum_1;
  add_cast_3 <= filter_products(2);
  add_temp_1 <= resize(add_cast_2, 17) + resize(add_cast_3, 17);
  sum_2 <= add_temp_1(15 DOWNTO 0);

  add_cast_4 <= sum_2;
  add_cast_5 <= filter_products(3);
  add_temp_2 <= resize(add_cast_4, 17) + resize(add_cast_5, 17);
  sum_3 <= add_temp_2(15 DOWNTO 0);

  add_cast_6 <= sum_3;
  add_cast_7 <= filter_products(4);
  add_temp_3 <= resize(add_cast_6, 17) + resize(add_cast_7, 17);
  sum_4 <= add_temp_3(15 DOWNTO 0);

  add_cast_8 <= sum_4;
  add_cast_9 <= filter_products(5);
  add_temp_4 <= resize(add_cast_8, 17) + resize(add_cast_9, 17);
  sum_5 <= add_temp_4(15 DOWNTO 0);

  add_cast_10 <= sum_5;
  add_cast_11 <= filter_products(6);
  add_temp_5 <= resize(add_cast_10, 17) + resize(add_cast_11, 17);
  sum_6 <= add_temp_5(15 DOWNTO 0);

  add_cast_12 <= sum_6;
  add_cast_13 <= filter_products(7);
  add_temp_6 <= resize(add_cast_12, 17) + resize(add_cast_13, 17);
  sum_7 <= add_temp_6(15 DOWNTO 0);

  add_cast_14 <= sum_7;
  add_cast_15 <= filter_products(8);
  add_temp_7 <= resize(add_cast_14, 17) + resize(add_cast_15, 17);
  sum_8 <= add_temp_7(15 DOWNTO 0);

  add_cast_16 <= sum_8;
  add_cast_17 <= filter_products(9);
  add_temp_8 <= resize(add_cast_16, 17) + resize(add_cast_17, 17);
  sum_9 <= add_temp_8(15 DOWNTO 0);

  add_cast_18 <= sum_9;
  add_cast_19 <= filter_products(10);
  add_temp_9 <= resize(add_cast_18, 17) + resize(add_cast_19, 17);
  sum_10 <= add_temp_9(15 DOWNTO 0);

  add_cast_20 <= sum_10;
  add_cast_21 <= filter_products(11);
  add_temp_10 <= resize(add_cast_20, 17) + resize(add_cast_21, 17);
  sum_11 <= add_temp_10(15 DOWNTO 0);

  add_cast_22 <= sum_11;
  add_cast_23 <= filter_products(12);
  add_temp_11 <= resize(add_cast_22, 17) + resize(add_cast_23, 17);
  sum_12 <= add_temp_11(15 DOWNTO 0);

  add_cast_24 <= sum_12;
  add_cast_25 <= filter_products(13);
  add_temp_12 <= resize(add_cast_24, 17) + resize(add_cast_25, 17);
  sum_13 <= add_temp_12(15 DOWNTO 0);

  add_cast_26 <= sum_13;
  add_cast_27 <= filter_products(14);
  add_temp_13 <= resize(add_cast_26, 17) + resize(add_cast_27, 17);
  sum_14 <= add_temp_13(15 DOWNTO 0);

  add_cast_28 <= sum_14;
  add_cast_29 <= filter_products(15);
  add_temp_14 <= resize(add_cast_28, 17) + resize(add_cast_29, 17);
  filter_sum <= add_temp_14(15 DOWNTO 0);

  LMS_Filter_out1 <= filter_sum;

-- * Calculate Filter Error

  sub_cast <= d_k_signed;
  sub_cast_1 <= filter_sum;
  sub_temp <= resize(sub_cast, 17) - resize(sub_cast_1, 17);
  LMS_Filter_out2 <= sub_temp(15 DOWNTO 0);

-- ***** LMS Weight Update Function *****

  mul_temp_16 <= C_LMS_FILTER_STEP_SIZE * LMS_Filter_out2;
  mu_err <= resize(shift_right(mul_temp_16(31) & mul_temp_16(31 DOWNTO 0) + ( "0" & (mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17) & NOT mul_temp_16(17))), 17), 16);

  mul_temp_17 <= data_pipeline(0) * mu_err;
  mu_err_data_prod(0) <= resize(shift_right(mul_temp_17(29 DOWNTO 0) + ( "0" & (mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14) & NOT mul_temp_17(14))), 14), 16);

  mul_temp_18 <= data_pipeline(1) * mu_err;
  mu_err_data_prod(1) <= resize(shift_right(mul_temp_18(29 DOWNTO 0) + ( "0" & (mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14) & NOT mul_temp_18(14))), 14), 16);

  mul_temp_19 <= data_pipeline(2) * mu_err;
  mu_err_data_prod(2) <= resize(shift_right(mul_temp_19(29 DOWNTO 0) + ( "0" & (mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14) & NOT mul_temp_19(14))), 14), 16);

  mul_temp_20 <= data_pipeline(3) * mu_err;
  mu_err_data_prod(3) <= resize(shift_right(mul_temp_20(29 DOWNTO 0) + ( "0" & (mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14) & NOT mul_temp_20(14))), 14), 16);

  mul_temp_21 <= data_pipeline(4) * mu_err;
  mu_err_data_prod(4) <= resize(shift_right(mul_temp_21(29 DOWNTO 0) + ( "0" & (mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14) & NOT mul_temp_21(14))), 14), 16);

  mul_temp_22 <= data_pipeline(5) * mu_err;
  mu_err_data_prod(5) <= resize(shift_right(mul_temp_22(29 DOWNTO 0) + ( "0" & (mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14) & NOT mul_temp_22(14))), 14), 16);

  mul_temp_23 <= data_pipeline(6) * mu_err;
  mu_err_data_prod(6) <= resize(shift_right(mul_temp_23(29 DOWNTO 0) + ( "0" & (mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14) & NOT mul_temp_23(14))), 14), 16);

  mul_temp_24 <= data_pipeline(7) * mu_err;
  mu_err_data_prod(7) <= resize(shift_right(mul_temp_24(29 DOWNTO 0) + ( "0" & (mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14) & NOT mul_temp_24(14))), 14), 16);

  mul_temp_25 <= data_pipeline(8) * mu_err;
  mu_err_data_prod(8) <= resize(shift_right(mul_temp_25(29 DOWNTO 0) + ( "0" & (mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14) & NOT mul_temp_25(14))), 14), 16);

  mul_temp_26 <= data_pipeline(9) * mu_err;
  mu_err_data_prod(9) <= resize(shift_right(mul_temp_26(29 DOWNTO 0) + ( "0" & (mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14) & NOT mul_temp_26(14))), 14), 16);

  mul_temp_27 <= data_pipeline(10) * mu_err;
  mu_err_data_prod(10) <= resize(shift_right(mul_temp_27(29 DOWNTO 0) + ( "0" & (mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14) & NOT mul_temp_27(14))), 14), 16);

  mul_temp_28 <= data_pipeline(11) * mu_err;
  mu_err_data_prod(11) <= resize(shift_right(mul_temp_28(29 DOWNTO 0) + ( "0" & (mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14) & NOT mul_temp_28(14))), 14), 16);

  mul_temp_29 <= data_pipeline(12) * mu_err;
  mu_err_data_prod(12) <= resize(shift_right(mul_temp_29(29 DOWNTO 0) + ( "0" & (mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14) & NOT mul_temp_29(14))), 14), 16);

  mul_temp_30 <= data_pipeline(13) * mu_err;
  mu_err_data_prod(13) <= resize(shift_right(mul_temp_30(29 DOWNTO 0) + ( "0" & (mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14) & NOT mul_temp_30(14))), 14), 16);

  mul_temp_31 <= data_pipeline(14) * mu_err;
  mu_err_data_prod(14) <= resize(shift_right(mul_temp_31(29 DOWNTO 0) + ( "0" & (mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14) & NOT mul_temp_31(14))), 14), 16);

  mul_temp_32 <= data_pipeline(15) * mu_err;
  mu_err_data_prod(15) <= resize(shift_right(mul_temp_32(29 DOWNTO 0) + ( "0" & (mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14) & NOT mul_temp_32(14))), 14), 16);

-- * LMS_Filter Weight Accumulator

  add_cast_30 <= weight(0);
  add_cast_31 <= mu_err_data_prod(0);
  add_temp_15 <= resize(add_cast_30, 17) + resize(add_cast_31, 17);
  weight_adder_output(0) <= add_temp_15(15 DOWNTO 0);

  add_cast_32 <= weight(1);
  add_cast_33 <= mu_err_data_prod(1);
  add_temp_16 <= resize(add_cast_32, 17) + resize(add_cast_33, 17);
  weight_adder_output(1) <= add_temp_16(15 DOWNTO 0);

  add_cast_34 <= weight(2);
  add_cast_35 <= mu_err_data_prod(2);
  add_temp_17 <= resize(add_cast_34, 17) + resize(add_cast_35, 17);
  weight_adder_output(2) <= add_temp_17(15 DOWNTO 0);

  add_cast_36 <= weight(3);
  add_cast_37 <= mu_err_data_prod(3);
  add_temp_18 <= resize(add_cast_36, 17) + resize(add_cast_37, 17);
  weight_adder_output(3) <= add_temp_18(15 DOWNTO 0);

  add_cast_38 <= weight(4);
  add_cast_39 <= mu_err_data_prod(4);
  add_temp_19 <= resize(add_cast_38, 17) + resize(add_cast_39, 17);
  weight_adder_output(4) <= add_temp_19(15 DOWNTO 0);

  add_cast_40 <= weight(5);
  add_cast_41 <= mu_err_data_prod(5);
  add_temp_20 <= resize(add_cast_40, 17) + resize(add_cast_41, 17);
  weight_adder_output(5) <= add_temp_20(15 DOWNTO 0);

  add_cast_42 <= weight(6);
  add_cast_43 <= mu_err_data_prod(6);
  add_temp_21 <= resize(add_cast_42, 17) + resize(add_cast_43, 17);
  weight_adder_output(6) <= add_temp_21(15 DOWNTO 0);

  add_cast_44 <= weight(7);
  add_cast_45 <= mu_err_data_prod(7);
  add_temp_22 <= resize(add_cast_44, 17) + resize(add_cast_45, 17);
  weight_adder_output(7) <= add_temp_22(15 DOWNTO 0);

  add_cast_46 <= weight(8);
  add_cast_47 <= mu_err_data_prod(8);
  add_temp_23 <= resize(add_cast_46, 17) + resize(add_cast_47, 17);
  weight_adder_output(8) <= add_temp_23(15 DOWNTO 0);

  add_cast_48 <= weight(9);
  add_cast_49 <= mu_err_data_prod(9);
  add_temp_24 <= resize(add_cast_48, 17) + resize(add_cast_49, 17);
  weight_adder_output(9) <= add_temp_24(15 DOWNTO 0);

  add_cast_50 <= weight(10);
  add_cast_51 <= mu_err_data_prod(10);
  add_temp_25 <= resize(add_cast_50, 17) + resize(add_cast_51, 17);
  weight_adder_output(10) <= add_temp_25(15 DOWNTO 0);

  add_cast_52 <= weight(11);
  add_cast_53 <= mu_err_data_prod(11);
  add_temp_26 <= resize(add_cast_52, 17) + resize(add_cast_53, 17);
  weight_adder_output(11) <= add_temp_26(15 DOWNTO 0);

  add_cast_54 <= weight(12);
  add_cast_55 <= mu_err_data_prod(12);
  add_temp_27 <= resize(add_cast_54, 17) + resize(add_cast_55, 17);
  weight_adder_output(12) <= add_temp_27(15 DOWNTO 0);

  add_cast_56 <= weight(13);
  add_cast_57 <= mu_err_data_prod(13);
  add_temp_28 <= resize(add_cast_56, 17) + resize(add_cast_57, 17);
  weight_adder_output(13) <= add_temp_28(15 DOWNTO 0);

  add_cast_58 <= weight(14);
  add_cast_59 <= mu_err_data_prod(14);
  add_temp_29 <= resize(add_cast_58, 17) + resize(add_cast_59, 17);
  weight_adder_output(14) <= add_temp_29(15 DOWNTO 0);

  add_cast_60 <= weight(15);
  add_cast_61 <= mu_err_data_prod(15);
  add_temp_30 <= resize(add_cast_60, 17) + resize(add_cast_61, 17);
  weight_adder_output(15) <= add_temp_30(15 DOWNTO 0);

  LMS_Filter_acc_temp_process2 : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      weight <= (OTHERS => (OTHERS => '0'));
    ELSIF clk'event AND clk = '1' THEN
      IF enb = '1' THEN
        weight(0 TO 15) <= weight_adder_output(0 TO 15);
      END IF;
    END IF;
  END PROCESS LMS_Filter_acc_temp_process2;


  e_k <= std_logic_vector(LMS_Filter_out2);

  ce_out <= clk_enable;


END rtl;

